<?php
/**
 * @package WordPress
 * @subpackage Ciara Janson
 */
 
 /* Comments */
 
 function ciara_theme_comment( $comment, $args, $depth ) {
    $GLOBALS['comment'] = $comment;
    
    $class = get_comment_class(); 
    if( in_array( 'bypostauthor',$class ) ):
    ?>
         <div class="ans">
            <span class="askDetail">
                <img src="<?php bloginfo('template_directory');?>/images/ciara-sundori.jpg" />
            </span>
            <div class="ansCont">
                <div class="ansContBot">
                   <?php comment_text(); ?> 
                </div>
            </div>
        </div>
        
     <?php else: ?>
     <div class="ques">
            <span class="askDetail">
                Asked by
                <?php comment_author(); ?> 
                at <?php comment_time(); ?> 
                on <?php comment_date('d/m/y'); ?>.
            </span>
            <div class="quesCont">
                <div class="quesContBot">
                    <?php comment_text(); ?>
                </div>
            </div>
        </div>
     <?php endif;
           
}
 
 /*
 * Custom Post Type
 */
/*
 * Add Custom Post Type
 * Audio
 * Photos
 * Video 
*/
add_action( 'init', 'create_post_type' );
function create_post_type() {
  register_post_type( 'cjn_audio',
    array(
      'labels' => array(
        'name' => __( 'Audios' ),
        'singular_name' => __( 'Audio' ),
      ),
      'public' => true,
      'rewrite' => array('slug' => 'audios'),
      'supports' => array('title', 'editor', 'author','custom-fields'),
    )
  );
  register_post_type( 'cjn_photos',
    array(
      'labels' => array(
        'name' => __( 'Photos' ),
        'singular_name' => __( 'Photo' ),
      ),
      'public' => true,
      'rewrite' => array('slug' => 'photos'),
      'supports' => array('title', 'author','custom-fields'),
    )
  );
  register_post_type( 'cjn_videos',
    array(
      'labels' => array(
        'name' => __( 'Videos' ),
        'singular_name' => __( 'Videos' ),
      ),
      'public' => true,
      'rewrite' => array('slug' => 'videos'),
      'supports' => array('title', 'editor', 'author','custom-fields'),
    )
  );
}
 
/*
 * Returns The current Page
*/
function jw_get_current_page(){
    if(is_front_page())
        return 'home';
    if(is_404()) return '404';
    if(is_single()) return 'single';
    $currentLoc = array_filter(split('/',$_SERVER["REQUEST_URI"]));
    
    
    $pages = array(
        'biography'=>strtolower(get_option('cjn_page_title_biography')),
        'contact'=>strtolower(get_option('cjn_page_title_contact')),
        'links'=>strtolower(get_option('cjn_page_title_links')),
        'ask'=>strtolower(get_option('cjn_page_title_ask')),
        'blog'=>strtolower(get_option('cjn_page_title_blog')),
        'media'=>strtolower(get_option('cjn_page_title_media')),
        'audios'=>strtolower(get_option('cjn_page_title_audio')),
        'photos'=>strtolower(get_option('cjn_page_title_photos')),
        'videos'=>strtolower(get_option('cjn_page_title_videos')),
        'blogs'=>strtolower(get_option('cjn_page_title_single')),
    );
    foreach( $pages as $key=>$page):
        if(in_array($page,$currentLoc))
            return $key;
    endforeach; 
}

/*
* Read Latest twitter feed
* param: twitter username
* return latest twitter feed
*/

$twitter_user = get_option('cjn_twitter_link');
$twitterSettings = array('title'=>'Ciara Janson','count'=>1,'username'=>$twitter_user);

function twitterHandler($args){
    if( is_array($args) ) extract($args);
    else return array();
    
    if($count>200 || $count=='') $count = 5;
    $twitter_status = @simplexml_load_file("http://twitter.com/statuses/user_timeline/$username.xml?count=$count");
    return $twitter_status->status;
}

//display function of the text widget
function widgetTwitterDisplay(){
    global $twitterSettings;
    $var = $twitterSettings;
    if( $var['title'] || $var['count'] ){
        $ret = twitterHandler($var);
        if( $ret )
        foreach($ret as $item):
            //print_r($item);
            $parts = explode(" ",$item->text);
            foreach( $parts as $i=>$v ){
                $has = explode('http:',$v);
                if( count($has)>1 ){
                    $tmp = $has[1][0];
                    for($x=1; $x<strlen($has[1]);$x++ ){
                        if( $x%21 == 0 ) $tmp .=" <br />";
                        $tmp .= $has[1][$x];
                    }
                    $parts[$i] = "$has[0] <a target=\"_blank\" href=\"http:$has[1]\">http:$tmp</a>";
                }
            }
            $text = implode(" ",$parts);
            echo '"'.$text.'" <span class="fr">'.date('D d F, Y',strtotime($item->created_at)).'</span>';
        endforeach;
    }
}
     



/*
 * Custom Admin Panel
 * Coding start for Theme Option Page
*/


$themename = "Ciara Janson";
$shortname = "cjn";
// Coding start for Theme Option Page


$categories = get_categories('hide_empty=0&orderby=name');
$wp_cats = array();
foreach ($categories as $category_list ) {
       $wp_cats[$category_list->cat_ID] = $category_list->cat_name;
}
array_unshift($wp_cats, "Choose a category"); 

$options = array (
 
array( "name" => $themename." Options",
    "type" => "title"),
 

array( "name" => "Background Image",
    "type" => "section"),
array( "type" => "open"),

array( "name" => "Home Page Image",
    "desc" => "Home Page Background Image",
    "id" => $shortname."_home_page_image",
    "type" => "text",
    "std" => "images/home_page_image.jpg"),

array( "name" => "Biography Page Image",
    "desc" => "Biography Page Background Image",
    "id" => $shortname."_biography_page_image",
    "type" => "text",
    "std" => "images/biography_page_image.jpg"),

array( "name" => "Blog Page Image",
    "desc" => "Blog Page Background Image",
    "id" => $shortname."_blog_page_image",
    "type" => "text",
    "std" => "images/blog_page_image.jpg"),

array( "name" => "single Post Image",
    "desc" => "Singe Page Background Image",
    "id" => $shortname."_single_page_image",
    "type" => "text",
    "std" => "single_page_image.jpg"),

array( "name" => "Media Page Image",
    "desc" => "Media Page Background Image",
    "id" => $shortname."_media_page_image",
    "type" => "text",
    "std" => "images/media_page_image.jpg"),

array( "name" => "Audio Page Image",
    "desc" => "Audio Page Background Image",
    "id" => $shortname."_audios_page_image",
    "type" => "text",
    "std" => "images/audio_page_image.jpg"),

array( "name" => "Photos Page Image",
    "desc" => "Photos Page Background Image",
    "id" => $shortname."_photos_page_image",
    "type" => "text",
    "std" => "images/photos_page_image.jpg"),


array( "name" => "Videos Page Image",
    "desc" => "Videos Page Background Image",
    "id" => $shortname."_videos_page_image",
    "type" => "text",
    "std" => "images/videos_page_image.jpg"),

array( "name" => "404 Page Image",
    "desc" => "404 Page Background Image",
    "id" => $shortname."_404_page_image",
    "type" => "text",
    "std" => "images/404_page_image.jpg"),

array( "name" => "Single Page Image",
    "desc" => "Single Page Background Image",
    "id" => $shortname."_blogs_page_image",
    "type" => "text",
    "std" => "images/blogs_page_image.jpg"),

array( "name" => "Links Page Image",
    "desc" => "Biography Page Background Image",
    "id" => $shortname."_links_page_image",
    "type" => "text",
    "std" => "images/links_page_image.jpg"),

array( "name" => "Ask Page Image",
    "desc" => "Ask Page Background Image",
    "id" => $shortname."_ask_page_image",
    "type" => "text",
    "std" => "images/ask_page_image.jpg"),

array( "name" => "Contact Page Image",
    "desc" => "Contact Page Background Image",
    "id" => $shortname."_contact_page_image",
    "type" => "text",
    "std" => "images/contact_page_image.jpg"),

array( "type" => "close"),

// Links Block Starts
array( "name" => "Links",
    "type" => "section"),
array( "type" => "open"),

array( "name" => "Facebook Link",
    "desc" => "Enter Your Face book Link Here",
    "id" => $shortname."_facebook_link",
    "type" => "text",
    "std" => ""),

array( "name" => "Twitter link",
    "desc" => "Add Your twitter Link Here",
    "id" => $shortname."_twitter_link",
    "type" => "text",
    "std" => ""),

array( "name" => "Feedburner URL",
    "desc" => "Feedburner is a Google service that takes care of your RSS feed. Paste your Feedburner URL here to let readers see it in your website",
    "id" => $shortname."_feedburner",
    "type" => "text",
    "std" => get_bloginfo('rss2_url')),

array( "name" => "iText Code",
    "desc" => "Please input the iText Codes",
    "id" => $shortname."_iText",
    "type" => "text",
    "std" => ''),
    
array( "type" => "close"),



// Page Id And Slugs

array( "name" => "Page ID and Title",
    "type" => "section"),
array( "type" => "open"),
array( "name" => "Biography Page ID",
    "desc" => "Please Input the Biography Page's ID",
    "id" => $shortname."_page_ID_biography",
    "type" => "text",
    "std" => "6"),


array( "name" => "Biography Page Title",
    "desc" => "Please Input the Biography Page's Title What you put in the page title",
    "id" => $shortname."_page_title_biography",
    "type" => "text",
    "std" => "Biography"),
    
array( "name" => "Contact Page ID",
    "desc" => "Please Input the Contact Page's ID",
    "id" => $shortname."_page_ID_contact",
    "type" => "text",
    "std" => "12"),
    
    
array( "name" => "Contact Page Title",
    "desc" => "Please Input the Contact Page's Slug What you put in the page title",
    "id" => $shortname."_page_title_contact",
    "type" => "text",
    "std" => "contact-ciara"),

array( "name" => "Links Page ID",
    "desc" => "Please Input the Links Page's ID",
    "id" => $shortname."_page_ID_links",
    "type" => "text",
    "std" => "16"),
    
    
array( "name" => "Links Page Title",
    "desc" => "Please Input the Links Page's Slug What you put in the page title",
    "id" => $shortname."_page_title_links",
    "type" => "text",
    "std" => "links"),

array( "name" => "Ask Ciara Page ID",
    "desc" => "Please Input the Ask Ciara Page's ID",
    "id" => $shortname."_page_ID_ask",
    "type" => "text",
    "std" => "19"),
    
    
array( "name" => "Ask Ciara Page Title",
    "desc" => "Please Input the Ask Ciara Page's Slug What you put in the page title",
    "id" => $shortname."_page_title_ask",
    "type" => "text",
    "std" => "ask-ciara"),

array( "name" => "The Blog Page ID",
    "desc" => "Please Input the The Blog Page's ID",
    "id" => $shortname."_page_ID_blog",
    "type" => "text",
    "std" => "22"),
    
    
array( "name" => "The Blog Page Title",
    "desc" => "Please Input the Ask The Blog's Slug What you put in the page title",
    "id" => $shortname."_page_title_blog",
    "type" => "text",
    "std" => "the-blog"),

array( "name" => "The Media Page ID",
    "desc" => "Please Input the  Media Page's ID",
    "id" => $shortname."_page_ID_media",
    "type" => "text",
    "std" => "34"),
    
    
array( "name" => "The Media Page Title",
    "desc" => "Please Input the Media's Slug What you put in the page title",
    "id" => $shortname."_page_title_media",
    "type" => "text",
    "std" => "media"),

array( "name" => "Audio Page ID",
    "desc" => "Please Input the  Media Page's ID",
    "id" => $shortname."_page_ID_audio",
    "type" => "text",
    "std" => "47"),
    
array( "name" => "Audio Page Title",
    "desc" => "Please Input Audio's Slug What you put in the page title",
    "id" => $shortname."_page_title_audio",
    "type" => "text",
    "std" => "audio"),

array( "name" => "Audio Page ID",
    "desc" => "Please Input the  Photo Page's ID",
    "id" => $shortname."_page_ID_photos",
    "type" => "text",
    "std" => "63"),
    
array( "name" => "Photos Page Title",
    "desc" => "Please Input Photo's Slug What you put in the page title",
    "id" => $shortname."_page_title_photos",
    "type" => "text",
    "std" => "photos"),

array( "name" => "Video Page ID",
    "desc" => "Please Input the  Video Page's ID",
    "id" => $shortname."_page_ID_videos",
    "type" => "text",
    "std" => "65"),
    
array( "name" => "Video Page Title",
    "desc" => "Please Input Video's Slug What you put in the page title",
    "id" => $shortname."_page_title_videos",
    "type" => "text",
    "std" => "videos"),
    
array( "name" => "Blog Page Title",
    "desc" => "Please Input Blog's Slug What you put in the page title",
    "id" => $shortname."_page_title_single",
    "type" => "text",
    "std" => "blog-post"),
    
array( "type" => "close"),

// Media Page text

array( "name" => "Text for Media Page",
    "type" => "section"),
array( "type" => "open"),

array( "name" => "text for Audio Block",
    "desc" => "Please add text for Audio Block in the Media Page",
    "id" => $shortname."_media_audio",
    "type" => "textarea"),
    
array( "name" => "text for Picture gallery Block",
    "desc" => "Please add text for Picture gallery in the Media Page",
    "id" => $shortname."_media_picture",
    "type" => "textarea"),
    
array( "name" => "text for Video Block",
    "desc" => "Please add text for Video Block in the Media Page",
    "id" => $shortname."_media_video",
    "type" => "textarea"),

array( "type" => "close"),
// Sidebar Option Ends
array( "name" => "iText",
    "type" => "section"),
array( "type" => "open"),

array( "name" => "404 Page text",
    "desc" => "Add iText code for 404 page",
    "id" => $shortname."_itext_404",
    "type" => "textarea",
    "std" => "Text For 404 Page"),

array( "name" => "biography Page text",
    "desc" => "Add iText code for biography page",
    "id" => $shortname."_itext_biography",
    "type" => "textarea",
    "std" => "Text For biography Page"),
    

array( "name" => "Home Page text",
    "desc" => "Add iText code for home page",
    "id" => $shortname."_itext_home",
    "type" => "textarea",
    "std" => "Text For Home Page"),

array( "name" => "single Page text",
    "desc" => "Add iText code for single page",
    "id" => $shortname."_itext_single",
    "type" => "textarea",
    "std" => "Text For single Page"),

array( "name" => "contact Page text",
    "desc" => "Add iText code for contact page",
    "id" => $shortname."_itext_contact",
    "type" => "textarea",
    "std" => "Text For contact Page"),
    
array( "name" => "links Page text",
    "desc" => "Add iText code for links page",
    "id" => $shortname."_itext_links",
    "type" => "textarea",
    "std" => "Text For links Page"),

array( "name" => "ask Page text",
    "desc" => "Add iText code for ask page",
    "id" => $shortname."_itext_ask",
    "type" => "textarea",
    "std" => "Text For ask Page"),

array( "name" => "blog Page text",
    "desc" => "Add iText code for blog page",
    "id" => $shortname."_itext_blog",
    "type" => "textarea",
    "std" => "Text For blog Page"),

array( "name" => "media Page text",
    "desc" => "Add iText code for media page",
    "id" => $shortname."_itext_media",
    "type" => "textarea",
    "std" => "Text For media Page"),
    
array( "name" => "audios Page text",
    "desc" => "Add iText code for audios page",
    "id" => $shortname."_itext_audios",
    "type" => "textarea",
    "std" => "Text For audios Page"),

array( "name" => "videos Page text",
    "desc" => "Add iText code for videos page",
    "id" => $shortname."_itext_videos",
    "type" => "textarea",
    "std" => "Text For videos Page"),

array( "name" => "blog Page text",
    "desc" => "Add iText code for blog page",
    "id" => $shortname."_itext_blog",
    "type" => "textarea",
    "std" => "Text For single blog"),

array( "name" => "photos Page text",
    "desc" => "Add iText code for photos page",
    "id" => $shortname."_itext_photos",
    "type" => "textarea",
    "std" => "Text For photos Page"),

    
array( "type" => "close"),
 
 
);


function mytheme_add_admin() {
 
global $themename, $shortname, $options;
 
if ( $_GET['page'] == basename(__FILE__) ) {
 
    if ( 'save' == $_REQUEST['action'] ) {
 
        foreach ($options as $value) {
        update_option( $value['id'], $_REQUEST[ $value['id'] ] ); }
 
foreach ($options as $value) {
    if( isset( $_REQUEST[ $value['id'] ] ) ) { update_option( $value['id'], $_REQUEST[ $value['id'] ]  ); } else { delete_option( $value['id'] ); } }
 
    header("Location: admin.php?page=functions.php&saved=true");
die;
 
} 
else if( 'reset' == $_REQUEST['action'] ) {
 
    foreach ($options as $value) {
        delete_option( $value['id'] ); }
 
    header("Location: admin.php?page=functions.php&reset=true");
die;
 
}
}
 
add_menu_page($themename, $themename, 'administrator', basename(__FILE__), 'mytheme_admin');
}

function mytheme_add_init() {

$file_dir=get_bloginfo('template_directory');
wp_enqueue_style("functions", $file_dir."/functions/functions.css", false, "1.0", "all");
wp_enqueue_script("rm_script", $file_dir."/functions/rm_script.js", false, "1.0");

}
function mytheme_admin() {
 
global $themename, $shortname, $options;
$i=0;
 
if ( $_REQUEST['saved'] ) echo '<div id="message" class="updated fade"><p><strong>'.$themename.' settings saved.</strong></p></div>';
if ( $_REQUEST['reset'] ) echo '<div id="message" class="updated fade"><p><strong>'.$themename.' settings reset.</strong></p></div>';
 
?>
<div class="wrap rm_wrap">
<h2><?php echo $themename; ?> Settings</h2>
 
<div class="rm_opts">
<form method="post">
<?php foreach ($options as $value) {
switch ( $value['type'] ) {
 
case "open":
?>
 
<?php break;
 
case "close":
?>
 
</div>
</div>
<br />

 
<?php break;
 
case "title":
?>
<p>To easily use the <?php echo $themename;?> theme, you can use the menu below.</p>

 
<?php break;
 
case 'text':
?>

<div class="rm_input rm_text">
    <label for="<?php echo $value['id']; ?>"><?php echo $value['name']; ?></label>
     <input name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>" type="<?php echo $value['type']; ?>" value="<?php if ( get_settings( $value['id'] ) != "") { echo stripslashes(get_settings( $value['id'])  ); } else { echo $value['std']; } ?>" />
 <small><?php echo $value['desc']; ?></small><div class="clearfix"></div>
 
 </div>
<?php
break;
 
case 'textarea':
?>

<div class="rm_input rm_textarea">
    <label for="<?php echo $value['id']; ?>"><?php echo $value['name']; ?></label>
     <textarea name="<?php echo $value['id']; ?>" type="<?php echo $value['type']; ?>" cols="" rows=""><?php if ( get_settings( $value['id'] ) != "") { echo stripslashes(get_settings( $value['id']) ); } else { echo $value['std']; } ?></textarea>
 <small><?php echo $value['desc']; ?></small><div class="clearfix"></div>
 
 </div>
  
<?php
break;
 
case 'select':
?>

<div class="rm_input rm_select">
    <label for="<?php echo $value['id']; ?>"><?php echo $value['name']; ?></label>
    
<select name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>">
<?php foreach ($value['options'] as $option) { ?>
        <option <?php if (get_settings( $value['id'] ) == $option) { echo 'selected="selected"'; } ?>><?php echo $option; ?></option><?php } ?>
</select>

    <small><?php echo $value['desc']; ?></small><div class="clearfix"></div>
</div>
<?php
break;
 
case "checkbox":
?>

<div class="rm_input rm_checkbox">
    <label for="<?php echo $value['id']; ?>"><?php echo $value['name']; ?></label>
    
<?php if(get_option($value['id'])){ $checked = "checked=\"checked\""; }else{ $checked = "";} ?>
<input type="checkbox" name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>" value="true" <?php echo $checked; ?> />


    <small><?php echo $value['desc']; ?></small><div class="clearfix"></div>
 </div>
<?php break; 
case "section":

$i++;

?>

<div class="rm_section">
<div class="rm_title"><h3><img src="<?php bloginfo('template_directory')?>/functions/images/trans.png" class="inactive" alt="""><?php echo $value['name']; ?></h3><span class="submit"><input name="save<?php echo $i; ?>" type="submit" value="Save changes" />
</span><div class="clearfix"></div></div>
<div class="rm_options">

 
<?php break;
 
}
}
?>
 
<input type="hidden" name="action" value="save" />
</form>
<form method="post">
<p class="submit">
<input name="reset" type="submit" value="Reset" />
<input type="hidden" name="action" value="reset" />
</p>
</form>
<div style="font-size:9px; margin-bottom:10px;">Icons & Code: <a href="http://www.woothemes.com/2009/09/woofunction/">WooFunction</a></div>
 </div> 
 

<?php
}
?>
<?php
add_action('admin_init', 'mytheme_add_init');
add_action('admin_menu', 'mytheme_add_admin');
?>