<?php

/**

 * The Header for our theme.

 *

 * Displays all of the <head> section and everything up till <div id="main">

 *

 * @package WordPress

 * @subpackage Ciara Janson

 */

?><!DOCTYPE html>

<html <?php language_attributes(); ?>>

<head>

<meta charset="<?php bloginfo( 'charset' ); ?>" />

<title><?php

	/*

	 * Print the <title> tag based on what is being viewed.

	 */

	global $page, $paged;



	wp_title( '|', true, 'right' );



	// Add the blog name.

	bloginfo( 'name' );



	// Add the blog description for the home/front page.

	$site_description = get_bloginfo( 'description', 'display' );

	if ( $site_description && ( is_home() || is_front_page() ) )

		echo " | $site_description";



	// Add a page number if necessary:

	if ( $paged >= 2 || $page >= 2 )

		echo ' | ' . sprintf( __( 'Page %s' ), max( $paged, $page ) );



	?></title>

<meta name="description" content="Ciara Janson is an English actress and voice over artist best known for her role in Hollyoaks as Nicole Owen" />

<meta property="fb:page_id" content="283857918547" />

<link rel="stylesheet" type="text/css" media="all" href="<?php bloginfo( 'stylesheet_url' ); ?>" />

<link rel="pingback" href="<?php bloginfo( 'pingback_url' ); ?>" />

<?php

	/* We add some JavaScript to pages with the comment form

	 * to support sites with threaded comments (when in use).

	 */

	if ( is_singular() && get_option( 'thread_comments' ) )

		wp_enqueue_script( 'comment-reply' );



?>    

<script type="text/javascript" src="<?php echo get_bloginfo('template_directory'); ?>/scripts/cufon.js"></script>

<script type="text/javascript" src="<?php echo get_bloginfo('template_directory'); ?>/scripts/Steiner_300.font.js"></script>

<script type="text/javascript" src="<?php echo get_bloginfo('template_directory'); ?>/scripts/jquery.js"></script>

<script type="text/javascript" src="<?php echo get_bloginfo('template_directory'); ?>/scripts/ready.js"></script>

<script type="text/javascript" src="<?php echo get_bloginfo('template_directory'); ?>/scripts/supersized.2.0.js"></script>

<script type="text/javascript" src="<?php echo get_bloginfo('template_directory'); ?>/scripts/pngfix.js"></script>

<script type="text/javascript" src="<?php echo get_bloginfo('template_directory'); ?>/scripts/prettyPhoto/js/jquery.prettyPhoto.js"></script>

<link rel="stylesheet" href="<?php echo get_bloginfo('template_directory'); ?>/scripts/prettyPhoto/css/prettyPhoto.css" type="text/css" media="screen" />

<script type="text/javascript">

    Cufon.replace('h1,.home-cont h2,.home-cont h3,.bio-cont h2,.bio-cont h3,.link-cont h2,.link-cont h4');

</script>

<script type="text/javascript">  

    //Cufon.replace('#mainCont h1',{ fontFamily: 'Steinerlight' });

    $(function(){

        $.fn.supersized.options = {  

            startwidth: 1280,  

            startheight: 960,

            vertical_center: 0,

            slideshow: 0,

            navigation: 0,

            transition: 0, //0-None, 1-Fade, 2-slide top, 3-slide right, 4-slide bottom, 5-slide left

            pause_hover: 0,

            slide_counter: 0,

            slide_captions: 0,

            slide_interval: 3000  

        };

        $('#supersize').supersized(); 

    });

</script>

<?php

	/* Always have wp_head() just before the closing </head>

	 * tag of your theme, or you will break many plugins, which

	 * generally use this hook to add elements to <head> such

	 * as styles, scripts, and meta tags.

	 */

	wp_head();

?>

</head>



<body>

<!--Social buttons start here-->

    <?php $currentPage =  jw_get_current_page();?>

        <div class="socialBtn">

            <div class="socialMainCont"><a class="fb pngfix" href="<?php echo get_option('cjn_facebook_link'); ?>"><i>facebook</i></a>

                <div class="contText">

                <div class="contTextTop">

                    <p>

                       <iframe src="http://www.facebook.com/plugins/likebox.php?href=http%3A%2F%2Fwww.facebook.com%2FOfficial.CiaraJanson&amp;width=175&amp;colorscheme=light&amp;show_faces=false&amp;stream=false&amp;header=true&amp;height=62" scrolling="no" frameborder="0" style="border:none; overflow:hidden; width:175px; height:62px;" allowTransparency="true"></iframe>

Follow Ciara on Facebook

                    </p>

                </div>

                </div>

            </div>

            <div class="socialMainCont"><a class="tw pngfix" href="http://twitter.com/<?php echo get_option('cjn_twitter_link'); ?>"><i>twitter</i></a>

                <div class="contText">

                <div class="contTextTop">

                    <p>

                        Ciara's Latest Tweet :<br /><br />

                     <?php widgetTwitterDisplay(); ?>

                    </p>

                </div>

                </div>

            </div>

            <div class="socialMainCont"><a class="iText pngfix" href="javascript:"><i>insert text</i></a>

                <div class="contText">

                <div class="contTextTop">

                    <p>

                        <?php echo stripslashes(get_option('cjn_itext_'.$currentPage)); ?>

                    </p>

                </div>

                </div>

            </div>

            <div class="socialMainCont"><a class="preText pngfix" href="http://www.freshsparkcreative.com" target="_blank"><i>pre-set text/image</i></a>

                <div class="contText">

                <div class="contTextTop">

                    <p><a href="http://www.freshsparkcreative.com" target="_blank"><img src="<?php bloginfo('template_directory'); ?>/images/freash-spark.jpg" /></a></p>

                </div>

                </div>

            </div>

        </div>

        <!--Social buttons end here-->

    <div id="supersize">

        <img src="<?php echo get_option('cjn_'.$currentPage.'_page_image'); ?>" title=""/>

    </div>

    <?php 

        $media_pages = array('media','audios','photos','videos');

    ?>

    <!--Wrap start here-->

    <div class="wrap">

        <!--Navigation start here-->

        <div class="navigation pngfix">

            <ul class="top-nav">

                <li <?php if($currentPage == 'home') echo 'class="active";' ?> >

                    <a class="pngfix" href="<?php bloginfo('home'); ?>"><span class="pngfix">

                    <b class="pngfix">home</b></span></a>

                </li>

                <li <?php if($currentPage == 'biography') echo 'class="active";' ?> >

                    <a class="pngfix" href="<?php echo get_page_link(get_option('cjn_page_ID_biography')); ?>">

                    <span><b>BIOGRAPHY</b></span></a>

                </li>

                <li <?php if($currentPage == 'blog' || $currentPage == 'blogs' || $currentPage == 'single' ) echo 'class="active";' ?> >

                    <a class="pngfix" href="<?php echo get_page_link(get_option('cjn_page_ID_blog')); ?>">

                    <span><b>BLOG</b></span></a>

                </li>

                <li <?php if(in_array($currentPage,$media_pages)) echo 'class="active";' ?> >

                    <a class="pngfix" href="<?php echo get_page_link(get_option('cjn_page_ID_media')); ?>">

                    <span><b>MEDIA</b></span></a>

                </li>

                <li <?php if($currentPage == 'ask') echo 'class="active";' ?> >

                    <a class="pngfix" href="<?php echo get_page_link(get_option('cjn_page_ID_ask')); ?>">

                    <span><b>ASK CIARA</b></span></a>

                </li>

                <li  <?php if($currentPage == 'contact') echo 'class="active";' ?> >

                    <a class="pngfix" href="<?php echo get_page_link(get_option('cjn_page_ID_contact')); ?>">

                    <span><b>CONTACT</b></span></a>

                </li>

                <li <?php if($currentPage == 'links') echo 'class="active";' ?> >

                    <a class="pngfix" href="<?php echo get_page_link(get_option('cjn_page_ID_links')); ?>">

                    <span><b>LINKS</b></span></a>

                </li>

            </ul>

        </div>

        <!--Navigation end here-->

